!Test for Carl Barnes changes to OLETCL to run under C6 threading model
!The class was changed to no longer start another thread to host the OLE control.
!The OLE control is created on the currently open window. Worked fine for me.

!Test code from origial Jim Kane example that uses MS Scripting engine and Excel commands
!This test verfies it runs in MDI threaded frame                      

!The LOOP test shows memory use growing over time. After 10,000 loops memory was 200MB and 20,000 handles. 
!In my testing the reason is probably DESTROY(Ole) does not free memory nor handles, even after the window closes.
!So if your code does a repeated .Init() / .Kill() then you may want to change the class 
!to only CREATE once, and not DESTROY on KILL. Or only Destroy+Create if the ProgID changes.
!Reported as PTTS #41555

    program
!_abcdllmode_  equate(0)        decided not to be ABC and just compile it in. It is a little bit of code.
!_abclinkmode_ equate(1)
    INCLUDE 'TplEqu.CLW'
    INCLUDE 'KeyCodes.CLW'
    Include('oletcl6.inc')     !#c6fx# change name of file for C6 Threading

    map
Main            procedure
Client1Window   procedure
Client2Window   procedure
NonMdiWindow    procedure
TestNoWindow    procedure
DB              PROCEDURE (<STRING Sec>, STRING Info)
        module('Win32')
            OutputDebugString(*cstring dMsg),PASCAL,RAW,NAME('OutputDebugStringA'),dll(1)
            GetLastError(),LONG,PASCAL,DLL(1)
        end
    end !map
    CODE    
! TestNoWindow()   !Jim's orignal did not require a Window. This one does. This tests no window open.
    Main()
    return
!-----------------
Main    procedure

AppFrame APPLICATION('OLE TCL Test Frame'),AT(,,500,300),FONT('MS Sans Serif',8,,FONT:regular),SYSTEM,RESIZE,ICON(Icon:Frame)
       MENUBAR
         MENU('&File'),USE(?File)
           ITEM('E&xit'),USE(?Exit),LAST,STD(STD:Close)
         END
         ITEM('Test1!'),USE(?ClientWindow1)
         ITEM('Test2!'),USE(?ClientWindow2)
         ITEM('NoWin!'),USE(?NoWinWindow)
         MENU('NonMDI'),USE(?NonMDI)
            ITEM('Open NonMDI'),USE(?NonMDIOpen)
            ITEM('Start NonMDI'),USE(?NonMDIStart)
         END
         MENU('&Edit'),USE(?Edit)
            ITEM('Cut'),STD(STD:Cut)
            ITEM('Copy'),STD(STD:Copy)
            ITEM('Paste'),STD(STD:Paste)
         END
         MENU('&Window'),STD(STD:WindowList)
             ITEM('Tile'),STD(STD:TileWindow)
             ITEM('Cascade'),STD(STD:CascadeWindow)
             ITEM('Arrange'),STD(STD:ArrangeIcons)
         END
         MENU('&Help'),MSG('Windows Help')
           ITEM('STD:Help'),USE(?HelpStd),STD(STD:Help)
           ITEM('Contents STD:HelpIndex'),STD(STD:HelpIndex)
           ITEM('Search Help STD:HelpSearch'),STD(STD:HelpSearch)
           ITEM('How to Use Help STD:HelpOnHelp'),STD(STD:HelpOnHelp)
         END
         ITEM('Exit!'),USE(?Exit2),STD(STD:Close)
       END
       TOOLBAR
         BUTTON('Test 1'),AT(1,1,44,16),USE(?ClientFrame1),FLAT,LEFT,TIP('Open Client 1 Test Window')
         BUTTON('Test 2'),AT(51,1,44,16),USE(?ClientFrame2),FLAT,LEFT,TIP('Open Client 2 Test Window')
         BUTTON('No Win'),AT(101,1,44,16),USE(?NoWinFrame),FLAT,LEFT,TIP('No Window Window')
       END
     END
    CODE
    OPEN(AppFrame)
    Accept
        Case Accepted()
        of ?ClientWindow1 orof ?CLientFrame1 ; START(Client1Window)
        of ?ClientWindow2 orof ?CLientFrame2 ; START(Client2Window)
        of ?NoWinWindow   orof ?NoWinFrame   ; START(TestNoWindow)
        of ?NonMDIOpen                       ; NonMdiWindow()
        of ?NonMDIStart                      ; START(NonMdiWindow)
        end
        case event()
        of event:CloseWindow    ; DB('Frame','event:CloseWindow')
        of event:CloseDown      ; DB('Frame','event:CloseDown')
        end
    end
    Close(AppFrame)
    return
!------------
Client1Window    procedure
DriveLtr    string('C')
Test1       string(255)
Test2       string(255)

oletCl       oleTClType !dim FileSystemObject
Drivesobject cstring(20)!dim DrivesObject
DriveObject  cstring(20)!dim DriveObject
TotalSize    string(18) !dim TotalSize
FreeSpace    string(18) !dim FreeSpace
OleDebug    BYTE(1)

Loops   LONG(1000)     !for loop test       

NoDestroy   BYTE(0) 

Window WINDOW('Client 1 MDI'),AT(,,300,129),MDI,GRAY,SYSTEM,ICON(ICON:Child),FONT('Verdana',8), |
            RESIZE
        PROMPT('Drive:'),AT(4,7),USE(?PROMPT1)
        ENTRY(@s1),AT(28,5,36,12),USE(DriveLtr)
        PROMPT('Ole Debug:'),AT(125,4),USE(?PROMPT2)
        ENTRY(@n1),AT(166,4,36,12),USE(OleDebug),SKIP
        BUTTON('OK'),AT(12,71),USE(?OkBtn)
        BUTTON('Test &1'),AT(5,26),USE(?Test1Btn)
        STRING(@s255),AT(41,28),USE(Test1)
        BUTTON('Test &2'),AT(5,43),USE(?Test2Btn)
        STRING(@s255),AT(41,46),USE(Test2)
        BUTTON('Std:Close'),AT(48,71),USE(?CloseBtn),STD(STD:Close)
        PROMPT('&Loops to Test:'),AT(177,68),USE(?PROMPT3)
        ENTRY(@n11),AT(230,68),USE(Loops)
        BUTTON('&Start'),AT(230,87,26),USE(?LoopStartBtn)
        BUTTON('&Stop'),AT(262,87,26),USE(?LoopStopBtn),DISABLE
        CHECK('No Destroy'),AT(178,90),USE(NoDestroy),TIP('Oletcl.NoDestroyOnKill<13,10>Ma' & |
                'y prevent memory leak')
        STRING('Test 1 and 2 use the Scripting.FileSystemObject OLE to get disk use'),AT(5,112)
    END
    code
    open(Window) ; 0{prop:Text}=clip(0{prop:Text}) & ' - Thread ' & Thread()
    accept
        case EVENT()
        of event:OpenWindow 
        of event:CloseWindow ; DB('child1','event:CloseWindow')
        of event:CloseDown   ; DB('child1','event:CloseDown')    ! ; cycle
        of event:timer       
            if Loops < 1 THEN 
               post(event:Accepted,?LoopStopBtn)
            elsif Loops % 2 THEN
               DO TEst1rtn ; Loops -= 1
            else    
               DO TEst2rtn ; Loops -= 1
            end    
        end
        case FIELD()
        end
        case ACCEPTED()
        OF ?OkBtn
        OF ?Test1Btn ; DO TEst1rtn
        OF ?Test2Btn ; DO TEst2rtn  
        OF ?LoopStartBtn ; IF ~Loops then Loops=1000. ; disable(?LoopStartBtn) ; enable(?LoopStopBtn); 0{prop:timer}=2
        OF ?LoopStopBtn ;                               enable(?LoopStartBtn)  ; disable(?LoopStopBtn); 0{prop:timer}=0   
        OF ?NoDestroy ; Oletcl.NoDestroyOnKill = NoDestroy
        end
    end
    close(Window)
    
!Original Test Code    
TEst1rtn routine
    data
    code
    oletcl.init('Scripting.FileSystemObject',OleDebug)
    TotalSize = oletcl.getprop('Drives.item("' & DriveLtr & '").TotalSize')  ! message(Format(oletcl.getprop('Drives.item("C").TotalSize'),@n18))
    FreeSpace = oletCl.getprop('Drives.item("' & DriveLtr & '").FreeSpace')  ! message(Format(oletCl.getprop('Drives.item("C").FreeSpace'),@N18))
    Test1=DriveLtr & ': Totalsz=' & clip(TotalSize) &'  Free=' & clip(FreeSpace) & '  @' & format(clock(),@t5) &' FEQ=' & OleTcl.OLEFEQ[1] &' '& OleTcl.OLEobject[1]
    oletcl.kill()
    display

TEst2rtn routine
    data
    code
    oletcl.init('Scripting.FileSystemObject',OleDebug) !debug mode on
    oletcl.getobj('DRIVES', DrivesObject)
    oletcl.getobj(DrivesObject & '.Item("' & DriveLtr & '")', DriveObject)
    TotalSize = oletcl.callobj(DriveObject,'TotalSize')
        !message(TotalSize,'TotalSize')
    FreeSpace = oletcl.callobj(DriveObject,'FreeSpace')
        !Message(FreeSpace,'Free Space')    
!        oletCl.DebugInfoMsg()
    oletCl.releaseobj(DriveObject)
    oletCl.releaseobj(DrivesObject)
    Test2=DriveLtr & ': Totalsz=' & clip(TotalSize) &'  Free=' & clip(FreeSpace)  & '  @' & format(clock(),@t5) &' FEQ=' & OleTcl.OLEFEQ[1] &' '& OleTcl.OLEobject[1]
    oletcl.kill()
    display

!-----------------------------------
Client2Window    procedure

oletCl       oleTClType !dim FileSystemObject
cXLSName     cstring(File:MaxFilePath)
cApplication cstring(20)
OleDebug    BYTE(1)
Window WINDOW('Client 2 MDI'),AT(,,213,108),MDI,GRAY,SYSTEM,ICON(ICON:Child),FONT('Verdana',8), |
            DOUBLE
        PROMPT('Ole Debug:'),AT(125,5),USE(?PROMPT1)
        ENTRY(@n1),AT(166,4,36,12),USE(OleDebug),SKIP
        BUTTON('XLS Test'),AT(56,48),USE(?OkBtn)
        BUTTON('Std:Close'),AT(106,48),USE(?CloseBtn),STD(STD:Close)
        STRING('Test uses Excel.Application OLE to create an XLS'),AT(5,86)
    END
    code
    open(Window) ; 0{prop:Text}=clip(0{prop:Text}) & ' - Thread ' & Thread()
    accept
        case EVENT()
        of event:OpenWindow 
        end
        case FIELD()
        end
        case ACCEPTED()
        OF ?OkBtn      ; DO XlsTestRtn
        end
    end
    close(Window)
XlsTestRtn ROUTINE  
    !Original test code 
    cXlSname=clip(longpath()) & '\testsave' & clock() &'.xls'
    remove(cXLSname)
    oletcl.init('excel.application')
    oletcl.getobj('application',capplication)
    oletcl.callmethod('workbooks.add')
    oletcl.setprop('cells(1,1).value','test')
    oletcl.callmethod('activeworkbook.saveas("'&cXlsname&'")')
    oletcl.callmethod('quit()')
    oletcl.releaseobj(capplication,3)
    oletcl.kill()
    message('done - created|' & cXlSname)
    exit     
       
!-----------------------------------
!to see this run in Main() uncomment call to TestNoWindow() 
TestNoWindow    procedure   !Jim's orignal did not require a Window. This one does.
DriveLtr    string('C')
Test1       string(255)
oletCl       oleTClType !dim FileSystemObject
!Drivesobject cstring(20)!dim DrivesObject
!DriveObject  cstring(20)!dim DriveObject
TotalSize    string(18) !dim TotalSize
FreeSpace    string(18) !dim FreeSpace
    CODE    
    oletcl.init('Scripting.FileSystemObject',1)
    TotalSize = oletcl.getprop('Drives.item("' & DriveLtr & '").TotalSize')  ! message(Format(oletcl.getprop('Drives.item("C").TotalSize'),@n18))
    FreeSpace = oletCl.getprop('Drives.item("' & DriveLtr & '").FreeSpace')  ! message(Format(oletCl.getprop('Drives.item("C").FreeSpace'),@N18))
    oletcl.kill()
    Message(DriveLtr & ': Totalsz=' & clip(TotalSize) &'  Free=' & clip(FreeSpace) & '  @' & format(clock(),@t5) & |
            '||This failed because no window is open. Seems to work if STARTed from Frame. Does not if run without Frame.' & |
            '||TODO in the Class.Init warn, maybe if Prop:XPos is blank? XPos=' & 0{PROP:XPos}) 
    !this does nothing. Find a way to spot there is no window open.
    RETURN
    
!-----------------------------------
NonMdiWindow    procedure
Window WINDOW('Not MDI'),AT(,,206,110),FONT('Verdana',8,,),ICON(Icon:Child),SYSTEM,GRAY,DOUBLE
       BUTTON('OK'),AT(56,48),USE(?OkBtn)
       BUTTON('Std:Close'),AT(106,48),USE(?CloseBtn),STD(STD:Close)
     END
    code
    open(Window) ; 0{prop:Text}=clip(0{prop:Text}) & ' - Thread ' & Thread()
    accept
        case EVENT()
        of event:OpenWindow 
        end
        case FIELD()
        end
        case ACCEPTED()
        OF ?OkBtn
        end
    end
    close(Window)

!===============================
DB                   PROCEDURE (<STRING Sec>, STRING Info) 
DBC     CSTRING(512),AUTO
    CODE
    IF ~OMITTED(1)
        DBC = CLIP(Sec) & ': ' & CLIP(Info) & '<13,10>'
    ELSE
        DBC = CLIP(Info)                    & '<13,10>'
    END
    OutputDebugString(DBC)
    RETURN

